#include "slBrevePluginAPI.h"
#include <math.h>

int cSampleTest(stEval args[], stEval *result, void *i);
int cSampleTestII(stEval args[], stEval *result, void *i);
int cSampleListTest(stEval args[], stEval *result, void *i);

/* our entry-point function: one call to stNewSteveCall for each function */

#ifdef WINDOWS
asm(".section .drectve");
asm(".ascii \"-export:cSampleLoadFunctions\"");
#endif /* WINDOWS */

cSampleLoadFunctions(void *data) {
	stNewSteveCall(data, "cSampleTest", cSampleTest, AT_NULL, AT_INT, AT_STRING, 0);
	stNewSteveCall(data, "cSampleTestII", cSampleTestII, AT_DOUBLE, 0);
	stNewSteveCall(data, "cSampleListTest", cSampleListTest, AT_NULL, AT_LIST, 0);
}

/* the first test function takes an int and string input, then prints *
 * them to the log output using the function slMessage.               */

int cSampleTest(stEval args[], stEval *result, void *i) {
	slMessage(0, "plugin function called with int %d and string \"%s\"\n", STINT(&args[0]), STSTRING(&args[1]));
	return EC_OK;
}

/* the second test function just returns a value and has no inputs */

int cSampleTestII(stEval args[], stEval *result, void *i) {
	STDOUBLE(result) = 3.14159;

	return EC_OK;
}

int cSampleListTest(stEval *args, stEval *result, void *i) { 
	stEvalListHead *myListHead = STLIST(&args[0]);
	stEvalList *list_ptr;
	int numNodes;
	double input1;
	double input2;

	numNodes = myListHead->count;
	printf("Total number of elements in list = %d.\n", numNodes);
	list_ptr = myListHead->start;
	input1 = STDOUBLE(&list_ptr->eval);
	printf("First Input = %d.\n", input1);
	list_ptr = list_ptr->next;
	input2 = STDOUBLE(&list_ptr->eval);
	printf("Second Input = %d.\n", input2);
	return EC_OK;
}
